<?php
/*
Plugin Name: Gregarious
Version: 1.6
Plugin URI: http://dev.lipidity.com/feature/wp-plugin-gregarious
Author: Ankur Kothari
Author URI: http://dev.lipidity.com/
Description: The ultimate social bookmarking plugin. Need I say more?
*/ 

/*
http://dev.lipidity.com/ for any help/support/requests/suggestions/updates
or send me an email at admin@lipidity.com

The plugin now boasts update checking. Just click "check for updates" at the bottom of the options page.
*/

//===========================================================================
// SHARE THIS STARTUP
//===========================================================================

if (function_exists('load_plugin_textdomain')) {
	load_plugin_textdomain('alexking.org');
}

@define('AK_WPROOT', '../../../');
@define('AKST_FILEPATH', '/wp-content/plugins/gregarious/gregarious.php');

//------------------------------------------
// Check email validity
//------------------------------------------

if (!function_exists('ak_check_email_address')) {
	function ak_check_email_address($email) {
// From: http://www.ilovejackdaniels.com/php/email-address-validation/
// First, we check that there's one @ symbol, and that the lengths are right
		if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
			// Email invalid because wrong number of characters in one section, or wrong number of @ symbols.
			return false;
		}
// Split it into sections to make life easier
		$email_array = explode("@", $email);
		$local_array = explode(".", $email_array[0]);
		for ($i = 0; $i < sizeof($local_array); $i++) {
			 if (!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i])) {
				return false;
			}
		}	
		if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) { // Check if domain is IP. If not, it should be valid domain name
			$domain_array = explode(".", $email_array[1]);
			if (sizeof($domain_array) < 2) {
					return false; // Not enough parts to domain
			}
			for ($i = 0; $i < sizeof($domain_array); $i++) {
				if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {
					return false;
				}
			}
		}
		return true;
	}
}

//===========================================================================
// RETURNING SHARE-THIS JS OR CSS?
//===========================================================================

if (!empty($_REQUEST['akst_action'])){
	doAKST ($_REQUEST['akst_action']);
	die();
}

function sharing()
{
	return (get_option('digg_showShare'));
}

//===========================================================================
// UPDATE CHECKING
//===========================================================================

@define('DIGG_BUILD', 5);

function updatesAvailable() {
//------------------------------------------
// Connect to server, check for new version
//------------------------------------------
	$ch = curl_init();
	
	curl_setopt($ch, CURLOPT_URL, "http://dev.lipidity.com/digg-update.txt");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
	$http_result = curl_exec($ch);
	
	curl_close($ch);
	
	$stresult = explode(" ", $http_result);

//------------------------------------------
// 0: Build no / 1: Version no / 3: DL URL
//------------------------------------------

	return $stresult;
}

//------------------------------------------
// Do the check if requested
//------------------------------------------

if(isset($_REQUEST['diggVersion'])){
    $checkUpdates = updatesAvailable();
    
    if($checkUpdates[0] > DIGG_BUILD){
    	echo "<h3>An upgrade to version " . $checkUpdates[1] . " is available. <a href='" . $checkUpdates[2] . "' title='Download the update as a zip file.'>Download it now</a> or <a href='http://dev.lipidity.com/dev/digg-this-wordpress-plugin-reloaded#download' title='Head over to Vacuous Virtuoso to find out more about this newest release.' target='_blank'>visit the site</a>.</h3>";
    } else {
    	echo "<h3>Congratulations, your plugin (version " . $str[1] . ") is up to date.</h3>";
    }
    exit;
}

//------------------------------------------
// First run, set defaults
//------------------------------------------

if(!get_option('digg_appendType') && !$_REQUEST['appendType']){
	resetEverything();
}

function clear_all_options(){
	delete_option('digg_submitLink');
	delete_option('digg_append');
	delete_option('digg_appendType');
	delete_option('digg_button');
	delete_option('digg_conditionals');
	delete_option('digg_before');
	delete_option('digg_after');
	delete_option('digg_whats_this');
	delete_option('digg_txt');
	delete_option('digg_notify');
	delete_option('digg_curl');
	delete_option('digg_showShare');
	delete_option('digg_shareTxt');
	delete_option('digg_reddit');
	delete_option('digg_redditStyle');
	delete_option('digg_appendAfter');
	delete_option('digg_afterReddit');
	delete_option('digg_inline');
	delete_option('digg_lastUpdateCheck');
}

function resetEverything(){
	update_option('digg_append',1);
	update_option('digg_curl',1);
	update_option('digg_appendType','button');
	update_option('digg_submitLink',1);
	update_option('digg_notify',1);
	$conditions1 = Array();
	$conditions1['is_single'] = true;
	$conditions1['is_home'] = true;
	$conditions1['is_page'] = true;
	$conditions1['is_category'] = false;
	$conditions1['is_date'] = false;
	update_option('digg_conditionals',$conditions1);
	update_option('digg_before', "<div class='diggWrap'>");
	update_option('digg_after', "</div>");
	update_option('digg_whats_this', 1);
	update_option('digg_txt', 'Digg this story');
	update_option('digg_button', 'http://digg.com/img/badges/32x32-digg-guy.gif');
	update_option('digg_showShare', 0);
	update_option('digg_shareTxt', 'Share elsewhere');
	update_option('digg_reddit', 0);
	update_option('digg_redditStyle', 3);
	update_option('digg_appendAfter', 1);
	update_option('digg_afterReddit', 0);
	update_option('digg_inline', 1);
}

//if(!get_option('digg_conditionals'))add_option('digg_conditionals',Array()); forgot y

//===========================================================================
// APPENDING / PREPENDING TO POSTS
//===========================================================================

//------------------------------------------
// We're asked to append to post
//------------------------------------------

if (get_option('digg_append')) {
	add_filter('the_content', 'button_hook');
}

function button_hook($content = ''){

	$result = '';

	//------------------------------------------
	// Are we meant to append?
	//------------------------------------------

	$conditionals = get_option('digg_conditionals');

	if ((is_home() and $conditionals['is_home']) or
		    (is_single() and $conditionals['is_single']) or
		    (is_page() and $conditionals['is_page']) or
		    (is_category() and $conditionals['is_category']) or
		    (is_date() and $conditionals['is_date']) or 0)
	{
		$result .= get_option('digg_before');
		
		$showButton = (get_option('digg_appendType')=="text") ? false : true;
		$result .= digg_this_reloaded(get_option('digg_txt'), "", get_option('digg_whats_this'), $showButton);
		
		$result .= get_option('digg_after');
		if(sharing())$result .= '<p class="akst_link">'.akst_share_link('return').'</p>';
	}

	//------------------------------------------
	// Before or after post content?
	//------------------------------------------

	if(get_option('digg_appendAfter')==1)
	{
		return $content.$result;
	}
	else
	{
		return $result.$content;
	}
}

//===========================================================================
// ADMIN MENU / OPTIONS PAGE
//===========================================================================

//------------------------------------------
// Admin page header
//------------------------------------------

add_action('admin_head', 'digg_admin_head');

function digg_admin_head()
{

//------------------------------------------
// Only if we're on Gregarious
//------------------------------------------

	if(str_replace('gregarious', '', $_SERVER['REQUEST_URI']) != $_SERVER['REQUEST_URI']){

?>
	<script src="<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/gregarious/js/prototype.js?ver=1.5.0"></script>
	<script src="<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/gregarious/js/addEvent.js"></script>
	<script src="<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/gregarious/js/sweetTitles.js"></script>

	<style>
		@import "<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/gregarious/css/sweetTitles.css";
	</style>
 <?
	}
}

//------------------------------------------
// The actual options page
//------------------------------------------

add_action('admin_menu', 'gregarious_admin_menu');

function gregarious_admin_menu()
{
	//add_submenu_page(parent, page_title, menu_title, access_level/capability, file, [function]);
	add_submenu_page('options-general.php', 'Gregarious Setup', 'Gregarious Options', 8, 'gregarious', 'gregarious_menu');
}

function gregarious_menu() {

	if ($_REQUEST['save'])
	{

	//------------------------------------------
	// Update options
	//------------------------------------------

		update_option('digg_submitLink', $_REQUEST['submitLink']);

	//------------------------------------------
	// Which types to show on
	//------------------------------------------

		$conditionals = Array();

		if (!$_REQUEST['conditionals'])
			$_REQUEST['conditionals'] = Array();

		foreach(get_option('digg_conditionals') as $condition=>$toggled)
			$conditionals[$condition] = array_key_exists($condition, $_REQUEST['conditionals']);

		update_option('digg_conditionals', $conditionals);

		update_option('digg_append', $_REQUEST['append']);
		update_option('digg_appendType', $_REQUEST['appendType']);

		update_option('digg_before', str_replace('"',"'", stripslashes($_REQUEST['prefix'])));
		update_option('digg_after', str_replace('"',"'", stripslashes($_REQUEST['suffix'])));

		update_option('digg_whats_this', $_REQUEST['linkBack']);
		update_option('digg_notify', $_REQUEST['notify']);
		update_option('digg_curl', $_REQUEST['curl']);

		update_option('digg_button', ($_REQUEST['diggButton'] != '')?$_REQUEST['diggButton']:"http://digg.com/img/badges/32x32-digg-guy.gif");

		update_option('digg_showShare', $_REQUEST['showShare']);
		update_option('digg_shareTxt', $_REQUEST['shareTxt']);

		update_option('digg_reddit', $_REQUEST['redditShow']);
		update_option('digg_redditStyle', $_REQUEST['redditStyle']);

		update_option('digg_appendAfter', $_REQUEST['appendAfter']);

		update_option('digg_afterReddit', $_REQUEST['diggAfter']);

		update_option('digg_inline', $_REQUEST['btnInline']);

		echo '<div id="message" class="updated fade"><p>Saved changes.</p></div>';
		
		/* Check for updates every three days */
		if(get_option('digg_lastUpdateCheck') < (time() - (3 * 24 * 60 * 60))){

			$str = updatesAvailable();

			if($str[0] > DIGG_BUILD)
			{
				$outputStr = "<div id='message' class='updated fade'><p>An upgrade to version ";
				$outputStr .= $str[1] . " is available. ";

				$outputStr .= "<a href='" . $str[2] . "' title='Download the update as a zip file.'>Download it now</a>";
				$outputStr .= " or <a href='http://dev.lipidity.com/dev/digg-this-wordpress-plugin-reloaded#download' title='Head over to Vacuous Virtuoso to find out more about this newest release.' target='_blank'>visit the site</a>.</p></div>";

				echo $outputStr;
    		}

    		update_option('digg_lastUpdateCheck', time());

		}
		/* End Check for updates */
		
	}  else if($_REQUEST['clear']){
	clear_all_options();
	resetEverything();
	echo '<div id="message" class="error fade"><p>Plugin cleared.</p></div>';
	}

//------------------------------------------
// Get our saved options
//------------------------------------------

	$conditionals = get_option('digg_conditionals');
	$append = get_option('digg_append');
	$submitLink = get_option('digg_submitLink');
	$appendType = get_option('digg_appendType');
	$diggButton = get_option('digg_button');
	$before = get_option('digg_before');
	$after = get_option('digg_after');
	$linkBack = get_option('digg_whats_this');
	$notify = get_option('digg_notify');
	$curlScrape = get_option('digg_curl');
	$showShare = get_option('digg_showShare');
	$shareTxt = get_option('digg_shareTxt');
	$redditShow = get_option('digg_reddit');
	$redditStyle = get_option('digg_redditStyle');
	$appendAfter = get_option('digg_appendAfter');
	$diggAfter = get_option('digg_afterReddit');
	$btnInline = get_option('digg_inline');

//------------------------------------------
// Display the admin menu
//------------------------------------------

?>

<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" id="form1" name="form1">

<div class="wrap" id="digg_options">
<fieldset>
<h2>Gregarious Plugin Setup</h2>
<? echo ($append) ? "" : "<div id='message' class='error fade'><p>Plugin not appending. <abbr title='You have disabled appending the Digg option to your posts automatically. For the Digg option to show, you need to add it to your template.'>[ ? ]</abbr></p></div>"; ?>
<h3>Digg.com</h3>

<div class="wrap">
<h3>Digg option</h3>
<p>Select the type of Digg option you want to provide your users. From here on in, this selection will be referred to as the &quot;Digg option&quot;.</p>
<p><select name="appendType"><option value="button"<?php echo ($appendType=="button") ? " selected" : ""; ?>>Button</option>
<option value="text"<?php echo ($appendType=="text") ? " selected" : ""; ?>>Text Link</option>
</select> <abbr title="The setting you choose here will determine how the Digging option will look. Setting it to button will produce an iframe allowing the user to Digg the post, or setting a simple text link will show exactly that; a text link! When you hear &quot;Digg option&quot; from now on, it means button or text link, depending on which one you&#39;ve chosen here.">[?]</abbr></p>

<p><input type="checkbox" id="linkBack" name="linkBack"<?php echo ($linkBack) ? " checked" : "" ?> /> <label for="linkBack">Show what&#39;s this link.</label></p>
</div>

<div class="wrap">
<h3>Undugg posts</h3>
<table width="100%"><tr><td><label for="submitLink">When post hasn&#39;t been dugg, show submit to Digg option</label></td>
<td><input type="checkbox" id="submitLink" name="submitLink"<?php echo ($submitLink) ? " checked" : ""; ?> /> <abbr title="If the post hasn't been dugg, you have the choive of either showing nothing by leaving this unchecked, or you can give your users a link to submit your post to Digg.com by ticking this checkbox.">[?]</abbr></td></tr>

<tr><td>Button to use (if Digg option is button)</td>
<td><input type="text" size="50" id="diggButton" name="diggButton" value=<?php echo ($diggButton) ? "'$diggButton'" : "''"; ?> /> <abbr title="If you're showing a &#39;submit to Digg&#39; link, and you've set button as your Digg option, you can change the image that appears here to link to the Digg submission form. The default is usually fine.<br />Preview: <img src='<? echo $diggButton ?>' />">[?]</abbr></td></tr>

<tr><td><label for="notify">Email admin when post is dugg?</label></td>
<td><input type="checkbox" id="notify" name="notify"<?php echo ($notify) ? " checked" : ""; ?> /> <abbr title="If you want an email sent to you once a post has been dugg, tick this checkbox.">[?]</abbr></td></tr>

<tr><td><label for="curl">Ensure Digg referrer is really for your post using CURL?</label></td>
<td><input type="checkbox" id="curl" name="curl"<?php echo ($curlScrape) ? " checked" : ""; ?> /> <abbr title="If you would like to the plugin to connect to the Digg page to make sure it's the correct Digg page, and not a comment or other link that's sent the referrer, tick this box. This way you don't have to check all your Dugg posts to make sure they're correct links. If your blog slows down a lot because of this, turn it off.">[?]</abbr></td></tr>
</table>
</div>

<h3>Reddit</h3>
<div class="wrap">
<h3>Reddit Button</h3>
<table width="100%">
<tr><td><label for="redditShow">Show Reddit Button: </label></td>
<td><input type="checkbox" id="redditShow" name="redditShow"<?php echo ($redditShow) ? " checked" : ""; ?> /> <abbr title="Enabling this option will show a button to allow integration with Reddit">[?]</abbr></td></tr>

<tr><td>Position:</td>
<td width="53%">
<input type="radio" id="redditPost1" name="diggAfter" value="1"<?php echo ($diggAfter==1) ? " checked" : ""; ?> /><label for="redditPos1">Before Digg button</label> 
<input type="radio" id="redditPos0" name="diggAfter" value="0"<?php echo ($diggAfter==0) ? " checked" : ""; ?> /><label for="redditPos0">After Digg buton</label> <abbr title="Choose whether you want the links to be automatically added at the bottom, or top of each post.">[?]</abbr></td></tr>

<tr><td><label for="redditStyle">Style of button (<a href="http://reddit.com/buttons" target="_blank" title="View the different button styles.">Info on the styles</a>):</label></td>
<td><select name="redditStyle">
<option value="1"<?php echo ($redditStyle==1) ? " selected" : ""; ?>>Horizontal</option>
<option value="2"<?php echo ($redditStyle==2) ? " selected" : ""; ?>>Button</option>
<option value="3"<?php echo ($redditStyle==3) ? " selected" : ""; ?>>Reddit Button</option>
</select> <abbr title="The setting you choose here will determine how the Reddit button will look. Default is Reddit Button (3rd style).">[?]</abbr></td></tr>
</table>
</div>

<h3>Auto-append</h3>
<div class="wrap">
<h3>Automatically add to content</h3>
<p>Gregarious can automatically add the social bookmarking links to each of your posts.</p>
<table width="100%"><tr><td><label for="append">Enable automatic append of links to posts.</label></td>
<td width="53%"><input type="checkbox" id="append" name="append"<?php echo ($append) ? " checked" : ""; ?> /> <abbr title="If you want the Digg button appearing at the bottom of your posts, check this option. Otherwise you can edit your template directly to get it to show by using the digg_this_reloaded function.">[?]</abbr></td></tr>

<tr><td>Attach to posts:</td>
<td width="53%">
<input type="radio" id="appendType0" name="appendAfter" value="0"<?php echo ($appendAfter==0) ? " checked" : ""; ?> /><label for="appendType0">Before content</label>
 <input type="radio" id="appendType1" name="appendAfter" value="1"<?php echo ($appendAfter==1) ? " checked" : ""; ?> /><label for="appendType1">After content</label> <abbr title="Choose whether you want the links to be automatically added at the bottom, or top of each post.">[?]</abbr></td></tr>
</table>

<p>Append link to posts on: <abbr title="Choose which pages you want the buttons to appear on.">[?]</abbr></p>
<ul style="list-style-type: none">
	<li><input type="checkbox" name="conditionals[is_home]" id="conditionals[is_home]"<?php echo ($conditionals['is_home']) ? " checked" : ""; ?>> <label for="conditionals[is_home]">Front page of the blog</label></li>
	<li><input type="checkbox" name="conditionals[is_single]" id="conditionals[is_single]"<?php echo ($conditionals['is_single']) ? " checked" : ""; ?>> <label for="conditionals[is_single]">Individual blog posts</label></li>
	<li><input type="checkbox" name="conditionals[is_page]" id="conditionals[is_page]"<?php echo ($conditionals['is_page']) ? " checked" : ""; ?>> <label for="conditionals[is_page]">Individual WordPress &quot;Pages&quot;</label></li>
	<li><input type="checkbox" name="conditionals[is_category]" id="conditionals[is_category]"<?php echo ($conditionals['is_category']) ? " checked" : ""; ?>> <label for="conditionals[is_category]">Category archives</label></li>
	<li><input type="checkbox" name="conditionals[is_date]" id="conditionals[is_date]"<?php echo ($conditionals['is_date']) ? " checked" : ""; ?>> <label for="conditionals[is_date]">Date-based archives</label></li>
</ul>

</div>

<div class="wrap">
<h3>Styling</h3>
<p>If you want, you can wrap the Digg and Reddit buttons in HTML tags for styling or positioning purposes. The Digg button and Reddit button are wrapped with divs with classes of 'diggButton' and 'redditButton' respectively.</p>
<table width="100%">
<tr><td><label for="prefix">Prefix: </label></td>
<td><input type="text" id="prefix" name="prefix" value="<?php echo $before; ?>" /> <abbr title="The HTML you want to have before the button. Most likely an opening tag such as div, p or span. Single quotes only.">[?]</abbr></td></tr>

<tr><td><label for="suffix">Suffix: </label></td>
<td><input type="text" id="suffix" name="suffix" value="<?php echo $after; ?>" /> <abbr title="This bit goes after the Digg option. You&#39;ll want to close any tags you have opened in the prefix. Single quotes only.">[?]</abbr></td></tr>

<p>Do you want the buttons to be on separate lines ('block'), or to be next to each other ('inline')?</p>
<table width="100%"><tr><td>Display style</td>
<td width="53%">
<input type="radio" id="btnInline1" name="btnInline" value="1"<?php echo ($btnInline==1) ? " checked" : ""; ?> /> 
<label for="btnInline1">Inline</label>
<input type="radio" id="btnInline0" name="btnInline" value="0"<?php echo ($btnInline==0) ? " checked" : ""; ?> /> 
<label for="btnInline0">Block</label>
<abbr title="Do you want the display style of your buttons to be block or inline? Block means they go on separate lines, while inline positions them next to each other.">[?]</abbr></td></tr>
</table>
</div>

<h2>More social bookmarking</h2>
<h3>Integration with Technorati, Delicious, Reddit, etc.</h3>
<div class="wrap">
<h3>Share this</h3>
<p>This enables a link on your posts to allow integration with other social bookmarking sites.</p>
<table width="100%">
<tr><td><label for="shareShow">Use share this link: </label></td>
<td><input type="checkbox" id="shareShow" name="showShare"<?php echo ($showShare) ? " checked" : ""; ?> /> <abbr title="Enabling this option will show a link after the Digg button that will allow the user to submit your article to other sites as well as Digg, including Delicious, Technorati, Reddit and more.">[?]</abbr></td></tr>
<tr><td><label for="shareTxt">Share this link: </label></td>
<td><input type="text" id="shareTxt" name="shareTxt" value="<?php echo $shareTxt; ?>" /> <abbr title="The text or HTML you want displayed as the link to open up the share this box.">[?]</abbr></td></tr>
</table>
</div>

</fieldset>

<p class="submit"><input name="clear" id="reset" accesskey="s" style='width:150px' value="Reset Options" type="submit" />
<input name="save" id="save" style='width:150px' accesskey="r" value="Save Changes" type="submit" /></p>
</div>

<fieldset>
<div class="wrap">
<script>
function updateCheck(){
	 $('updateDiv').innerHTML='Checking...';
     var url = '<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/gregarious/gregarious.php';
     var pars = 'diggVersion=<? echo DIGG_BUILD; ?>';
     var target = 'updateDiv';
     var myAjax = new Ajax.Updater(target, url, {method: 'get', parameters: pars});
}
</script>

<div id ="updateDiv" class='updated'>
<h3><a title='Click here to check for a newer version of this plugin' name="update-check" onclick="updateCheck()">Check for updates...</a></h3>
</div>

</div>
</fieldset>

</form>

<?php
}

//===========================================================================
// THE REAL STUFF
//===========================================================================

function _scrape_check_digg($digg_link, $the_permalink)
{    
    $ch = curl_init(); 
    curl_setopt($ch, CURLOPT_URL, $digg_link); 
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);         
    $http_result = curl_exec($ch);
    curl_close($ch);            
    $_ = preg_match('#<h3 id="title"><a href="(.*?)">#is', $http_result, $captures);
    return ($captures[1] == $the_permalink);
}

function show_digg_link()
{
   echo digg_this_reloaded("Digg It","",true,false);
}

function show_digg_button() {
	echo digg_this_reloaded("Digg It", "", false, true);
}

function digg_this_reloaded($link_text="Digg this story", $ping_str="", $show_what_is_this=true, $use_digg_button=true, $link='')
{
//   global $id;
	$resultDigg = "";
	$resultReddit = "";
	
	global $wp_query; 
	$post = $wp_query->post;
	$id = $post->ID;
	$permalink = ($link=='') ? get_permalink($id) : $link;
	$title = urlencode($post->post_title);
	
	$btnStyle = (get_option('digg_inline')==1) ? 'inline' : 'block';
	
	if(get_option('digg_reddit'))
	{
		$style = get_option('digg_redditStyle');
		$resultReddit .= "<div class='redditButton' style='display:" . $btnStyle . "'><script type='text/javascript'>reddit_url = '";//'
		$resultReddit .= $permalink;
		$resultReddit .= "';</script><script src='http://reddit.com/button.js?t=".$style."' type='text/javascript'></script></div>";
	}
	
   $WHAT_IS_THIS_TEXT = 'Learn more about the Gregarious plugin for Wordpress.';
   $orig_ref = $_SERVER['HTTP_REFERER'];
   $ref = strtolower($orig_ref);
   $referer_end = substr($orig_ref, -10);
   $digg_link = get_post_meta($id, 'DiggUrl', true);
   
   if ( $digg_link == '' && substr_count($ref, "_") > 0
   	&& strpos($ref, "digg.com") !== false
        && strpos($ref, "?") == false
        &&
        (strpos($ref, "digg.com")==0 || 
    	strpos($ref, "http://digg.com")==0 ||
    	strpos($ref, "www.digg.com")==0 ||
    	strpos($ref, "http://www.digg.com")==0)
      )
      {
	$CURLCheck = (get_option('digg_curl')) ? _scrape_check_digg($_SERVER['HTTP_REFERER'], get_permalink()) : true;
    if($CURLCheck){
      	/* this removes /who, /blog, and /share from the path */ 
	     
	    if(strpos($referer_end, "/who")) {
		$orig_ref = substr($referer, 0, $referer_len-4);
	    }
	    if(strpos($referer_end, "/blog")) {
		$orig_ref = substr($referer, 0, $referer_len-5);
	    }
	    if(strpos($referer_end, "/share")) {
		$orig_ref = substr($referer, 0, $referer_len-6);
	    }
	    
        $digg_link=$orig_ref; 
        add_post_meta($id, 'DiggUrl', $orig_ref);
        if(get_option ('digg_notify')) notify_moderator_on_digg($id, $orig_ref);
     }
      }

   if (substr_count(strtolower($digg_link),"digg.com"))
  	{
                if ($use_digg_button)
                {
					$resultDigg .= "<div class='diggButton' style='display:" . $btnStyle . "'>";
					$resultDigg .= "<script type='text/javascript'>";
					$resultDigg .= "//<![CDATA[\ndigg_url='".$digg_link."';\n//]]>\n";
					$resultDigg .= "</script>\n<script type='text/javascript' src='http://digg.com/api/diggthis.js'>\n</script>\n";
					$resultDigg .= "</div>";
					/*$resultDigg .= "<iframe src='http://digg.com/api/diggthis.php?u=".htmlspecialchars($digg_link)."' height='82' width='55' frameborder='0' scrolling='no'></iframe>";*/
                }
                else
                {
					$resultDigg .= "<a href='".$digg_link."' ping='".$permalink."$ping_str' target='_blank' title='Digg this story'>".$link_text."</a>";
					$resultDigg .= '&nbsp;<font size="-2"><a href="http://dev.lipidity.com/feature/digg-this-wordpress-plugin-reloaded" title="'.$WHAT_IS_THIS_TEXT.'">';
					
					if ($show_what_is_this) $resultDigg .= '[ ? ]';
					
					$resultDigg .= ' </a></font>';
                }
  	
  	} else if(get_option('digg_submitLink')) {

		if ($use_digg_button){
			$resultDigg .= "<a href='http://digg.com/submit?phase=2&amp;url=".htmlspecialchars($permalink)."&amp;title=".urlencode($post->post_title)."&amp;topic=' title='Bookmark this story on Digg.com'><img src='". get_option('digg_button') ."' class='imgDigg' alt='Digg!' /></a>";
		} else {
			$resultDigg .= "<a href='http://digg.com/submit?phase=2&amp;url=".htmlspecialchars($permalink)."&amp;title=".urlencode($post->post_title)."&amp;topic=' title='Bookmark this story on Digg.com' class='txtDigg'>Digg it</a>";
		}
	}
	if(get_option('digg_afterReddit')) {
		return $resultReddit.$resultDigg;
	} else {
		return $resultDigg.$resultReddit;
	}
}  

function notify_moderator_on_digg($post_id, $digg_ref ) {
	global $wpdb;
        
	if(get_option('digg_notify'))
		return false;
	
	$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID='$post_id' LIMIT 1");

	$notify_message  = sprintf( __('A new post was dugg by digg.com users. A link back to digg.com ( %1$s ) was automaticaly added to the post #%2$s "%3$s" 

'), $digg_ref, $post_id, $post->post_title ) . "\r\n";
	$notify_message .= get_permalink($post->ID) . "\r\n\r\n";
	$subject = sprintf( __('[%1$s] A post has been dugg: "%2$s"'), get_settings('blogname'), $post->post_title );
	$admin_email = get_settings('admin_email');

	$notify_message = apply_filters('post_dugg_text', $notify_message);
	$subject = apply_filters('post_dugg_subject', $subject);

	@wp_mail($admin_email, $subject, $notify_message);
    
	return true;
}

//===========================================================================
// SHARE STUFF
//===========================================================================

function akst_share_link($action = 'print') {
	if (function_exists('akm_check_mobile') && akm_check_mobile()) {
		return '';
	}
	global $post;
	ob_start();
?>
<a href="#" onclick="akst_share('<?php print($post->ID); ?>', '<?php print(urlencode(get_permalink($post->ID))); ?>', '<?php print(urlencode(get_the_title())); ?>'); return false;" title="<?php _e('E-mail this, post to del.icio.us, etc.', 'alexking.org'); ?>" id="akst_link_<?php print($post->ID); ?>"><?php _e(get_option('digg_shareTxt'), 'alexking.org'); ?></a>
<?php
	$link = ob_get_contents();
	ob_end_clean();
	switch ($action) {
		case 'print':
			print($link);
			break;
		case 'return':
			return $link;
			break;
	}
}



//===========================================================================
// HEAD CONTENT
//===========================================================================

function akst_head() {
	$wp = get_bloginfo('wpurl');
	$url = $wp.AKST_FILEPATH;
	print('
	<script type="text/javascript" src="'.$wp.'/wp-content/plugins/gregarious/js/prototype.js"></script>
	<script type="text/javascript" src="'.$url.'?akst_action=js"></script>
	<link rel="stylesheet" type="text/css" href="'.$url.'?akst_action=css" />
	');
}

//===========================================================================
// SHARE THIS JS / CSS
//===========================================================================

if(sharing()){
	add_action('wp_head', 'akst_head');
	add_action('wp_footer', 'akst_share_form');
}

function doAKST($type){

// Find more URLs here: 
// http://3spots.blogspot.com/2006/02/30-social-bookmarks-add-to-footer.html

$social_sites = array(
	'delicious' => array(
		'name' => 'del.icio.us'
		, 'url' => 'http://del.icio.us/post?url={url}&title={title}'
	)
	, 'digg' => array(
		'name' => 'Digg'
		, 'url' => 'http://digg.com/submit?phase=2&url={url}&title={title}'
	)
	, 'furl' => array(
		'name' => 'Furl'
		, 'url' => 'http://furl.net/storeIt.jsp?u={url}&t={title}'
	)
	, 'netscape' => array(
		'name' => 'Netscape'
		, 'url' => ' http://www.netscape.com/submit/?U={url}&T={title}'
	)
	, 'yahoo_myweb' => array(
		'name' => 'Yahoo! My Web'
		, 'url' => 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u={url}&t={title}'
	)
	, 'technorati' => array(
		'name' => 'Technorati'
		, 'url' => 'http://www.technorati.com/faves?add={url}'
	)
	, 'google_bmarks' => array(
		'name' => 'Google Bookmarks'
		, 'url' => '  http://www.google.com/bookmarks/mark?op=edit&amp;bkmk={url}&title={title}'
	)
	, 'newsvine' => array(
		'name' => 'Newsvine'
		, 'url' => 'http://www.newsvine.com/_wine/save?u={url}&h={title}'
	)
	, 'blinklist' => array(
		'name' => 'BlinkList'
		, 'url' => 'http://blinklist.com/index.php?Action=Blink/addblink.php&Url={url}&Title={title}'
	)
	, 'reddit' => array(
		'name' => 'reddit'
		, 'url' => 'http://reddit.com/submit?url={url}&title={title}'
	)
	, 'blogmarks' => array(
		'name' => 'Blogmarks'
		, 'url' => 'http://blogmarks.net/my/new.php?mini=1&amp;url={url}&title={title}'
	)
	, 'magnolia' => array(
		'name' => 'ma.gnolia'
		, 'url' => 'http://ma.gnolia.com/bookmarklet/add?url={url}&title={title}'
	)
	, 'windows_live' => array(
		'name' => 'Windows Live'
		, 'url' => 'https://favorites.live.com/quickadd.aspx?marklet=1&mkt=en-us&url={url}&title={title}&amp;top=1'
	)
	, 'tailrank' => array(
		'name' => 'Tailrank'
		, 'url' => 'http://tailrank.com/share/?link_href={url}&title={title}'
	)
);

	switch ($type) {
		case 'js':
			header("Content-type: text/javascript");
?>
function akst_share(id, url, title) {
	var form = $('akst_form');
	var post_id = $('akst_post_id');
	
	if (form.style.display == 'block' && post_id.value == id) {
		form.style.display = 'none';
		return;
	}
	
	var link = $('akst_link_' + id);
	var offset = Position.cumulativeOffset(link);

<?php
	foreach ($social_sites as $key => $data) {
		print('	$("akst_'.$key.'").href = akst_share_url("'.$data['url'].'", url, title);'."\n");
	}
?>

	post_id.value = id;

	form.style.left = offset[0] + 'px';
	form.style.top = (offset[1] + link.offsetHeight + 3) + 'px';
	form.style.display = 'block';
}

function akst_share_url(base, url, title) {
	base = base.replace('{url}', url);
	return base.replace('{title}', title);
}

function akst_share_tab(tab) {
	var tab1 = document.getElementById('akst_tab1');
	var tab2 = document.getElementById('akst_tab2');
	var body1 = document.getElementById('akst_social');
	var body2 = document.getElementById('akst_email');
	
	switch (tab) {
		case '1':
			tab2.className = '';
			tab1.className = 'selected';
			body2.style.display = 'none';
			body1.style.display = 'block';
			break;
		case '2':
			tab1.className = '';
			tab2.className = 'selected';
			body1.style.display = 'none';
			body2.style.display = 'block';
			break;
	}
}

function akst_xy(id) {
	var element = $(id);
	var x = 0;
	var y = 0;
}
<?php
			die();
			break;
		case 'css':
			header("Content-type: text/css");
?>
#akst_form {
	background: #999;
	border: 1px solid #ddd;
	display: none;
	position: absolute;
	width: 350px;
}
#akst_form a.akst_close {
	color: #fff;
	float: right;
	margin: 5px;
}
#akst_form ul.tabs {
	border: 1px solid #999;
	list-style: none;
	margin: 10px 10px 0 10px;
	padding: 0;
}
#akst_form ul.tabs li {
	background: #ccc;
	border-bottom: 1px solid #999;
	color: #fff;
	cursor: pointer;
	float: left;
	margin: 0 3px 0 0;
	padding: 3px 5px 2px 5px;
}
#akst_form ul.tabs li.selected {
	background: #fff;
	border-bottom: 1px solid #fff;
	color: #ccc;
	cursor: default;
	padding: 4px 5px 1px 5px;
}
#akst_form div.clear {
	clear: both;
	float: none;
}
#akst_social, #akst_email {
	background: #fff;
	border: 1px solid #fff;
	padding: 10px;
}
#akst_social ul {
	list-style: none;
	margin: 0;
	padding: 0;
}
#akst_social ul li {
	float: left;
	margin: 0;
	padding: 0;
	width: 45%;
}
#akst_social ul li a {
	display: block;
	float: left;
	height: 24px;
	padding: 4px 0 0 24px;
	vertical-align: middle;
}
<?php
foreach ($social_sites as $key => $data) {
	print(
'#akst_'.$key.' {
	background: url(share-this/'.$key.'.gif) no-repeat 2px center;
}
');
}
?>
#akst_email {
	display: none;
	text-align: left;
}
#akst_email form, #akst_email fieldset {
	border: 0;
	margin: 0;
	padding: 0;
}
#akst_email fieldset legend {
	display: none;
}
#akst_email ul {
	list-style: none;
	margin: 0;
	padding: 0;
}
#akst_email ul li {
	margin: 0 0 7px 0;
	padding: 0;
}
#akst_email ul li label {
	color: #555;
	display: block;
	margin-bottom: 3px;
}
#akst_email ul li input {
	padding: 3px 10px;
}
#akst_email ul li input.akst_text {
	padding: 3px;
	width: 280px;
}

<?php
			die();
			break;
		case 'send_mail':
			require(AK_WPROOT.'wp-blog-header.php');////AK_WPROOT.'wp-blog-header.php'

			if (function_exists('load_plugin_textdomain')) {
				load_plugin_textdomain('alexking.org');
			}

			$post_id = '';
			$to = '';
			$name = '';
			$email = '';
			
			if (!empty($_REQUEST['akst_to'])) {
				$to = stripslashes($_REQUEST['akst_to']);
				$to = str_replace(
					array(
						','
						,"\n"
						,"\t"
						,"\r"
					)
					, array()
					, $to
				);
			}
			
			if (!empty($_REQUEST['akst_name'])) {
				$name = stripslashes($_REQUEST['akst_name']);
				$name = str_replace(
					array(
						'"'
						,"\n"
						,"\t"
						,"\r"
					)
					, array()
					, $name
				);
			}

			if (!empty($_REQUEST['akst_email'])) {
				$email = stripslashes($_REQUEST['akst_email']);
				$email = str_replace(
					array(
						','
						,"\n"
						,"\t"
						,"\r"
					)
					, array()
					, $email
				);
			}
			
			if (!empty($_REQUEST['akst_post_id'])) {
				$post_id = intval($_REQUEST['akst_post_id']);
			}

			if (empty($post_id) || empty($to) || !ak_check_email_address($to) || empty($email) || !ak_check_email_address($email)) {
				wp_die(__('Click your <strong>back button</strong> and make sure those e-mail addresses are valid then try again.', 'alexking.org'));
			}
			
			$post = &get_post($post_id);
			
			$url = get_permalink($post_id);
			
			$headers = "MIME-Version: 1.0\n" .
				'From: "'.$name.'" <'.$email.'>'."\n"
				.'Reply-To: "'.$name.'" <'.$email.'>'."\n"
				.'Return-Path: "'.$name.'" <'.$email.'>'."\n"
				."Content-Type: text/plain; charset=\"" . get_option('blog_charset') ."\"\n";
			
			$subject = __('Check out this post on ', 'alexking.org').get_bloginfo('name');
			
			$message = __('Greetings--', 'alexking.org')."\n\n"
				.$name.__(' thinks this will be of interest to you:', 'alexking.org')."\n\n"
				.$url."\n\n"
				.__('Enjoy.', 'alexking.org')."\n\n"
				.'--'."\n"
				.get_bloginfo('home')."\n";
			
			@mail($to, $subject, $message, $headers);
			
			if (!empty($_SERVER['HTTP_REFERER'])) {
				$url = $_SERVER['HTTP_REFERER'];
			}
			
			header("Location: $url");
			status_header('302');
			die();
			
			/*include './share-this/share-this.php';*/
			break;
			
		case 'footer':
			global $post, $current_user;

			if (isset($current_user)) {
				$user = get_currentuserinfo();
				$name = $current_user->user_nicename;
				$email = $current_user->user_email;
			}
			else {
				$user = wp_get_current_commenter();
				$name = $user['comment_author'];
				$email = $user['comment_author_email'];
			}
		?>
	<!-- Share This BEGIN -->
	<div id="akst_form">
		<a href="javascript:void($('akst_form').style.display='none');" class="akst_close"><?php _e('Close', 'alexking.org'); ?></a>
		<ul class="tabs">
			<li id="akst_tab1" class="selected" onclick="akst_share_tab('1');"><?php _e('Social Web', 'alexking.org'); ?></li>
			<li id="akst_tab2" onclick="akst_share_tab('2');"><?php _e('E-mail', 'alexking.org'); ?></li>
		</ul>
		<div class="clear"></div>
		<div id="akst_social">
			<ul>
<?php
	foreach ($social_sites as $key => $data) {
		print('				<li><a href="#" id="akst_'.$key.'">'.$data['name'].'</a></li>'."\n");
	}
?>
			</ul>
			<div class="clear"></div>
		</div>
		<div id="akst_email">
			<form action="<?php print(get_bloginfo('wpurl').AKST_FILEPATH); ?>" method="post">
				<fieldset>
					<legend><?php _e('E-mail It', 'alexking.org'); ?></legend>
					<ul>
						<li>
							<label><?php _e('To Address:', 'alexking.org'); ?></label>
							<input type="text" name="akst_to" value="" class="akst_text" />
						</li>
						<li>
							<label><?php _e('Your Name:', 'alexking.org'); ?></label>
							<input type="text" name="akst_name" value="<?php print(htmlspecialchars($name)); ?>" class="akst_text" />
						</li>
						<li>
							<label><?php _e('Your Address:', 'alexking.org'); ?></label>
							<input type="text" name="akst_email" value="<?php print(htmlspecialchars($email)); ?>" class="akst_text" />
						</li>
						<li>
							<input type="submit" name="akst_submit" value="<?php _e('Send It', 'alexking.org'); ?>" />
						</li>
					</ul>
					<input type="hidden" name="akst_action" value="send_mail" />
					<input type="hidden" name="akst_post_id" id="akst_post_id" value="" />
				</fieldset>
			</form>
		</div>
	</div>
	<!-- Share This END -->
<?php
			break;
	}
}

function akst_share_form(){
	doAKST('footer');	
}
?>